Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Sony.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Sony.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Sony.pm	(revision 34921)
@@ -1055,9 +5498,286 @@
 );
 
+# extra hardware information (ref JR)
+%Image::ExifTool::Sony::ExtraInfo = (
+    %binaryDataAttrs,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    NOTES => 'Extra hardware information for the A850 and A900.',
+    # 0x0000: seen values 5 or 6
+    0x0001 => {
+        Name => 'BatteryTemperature',
+        # seen values of appr. 55 - 115: looks like temperature Fahrenheit
+        # changing battery in cold weather: new battery starts with value 53
+        ValueConv => '($val - 32) / 1.8', # convert to Celsius
+        ValueConvInv => '$val * 1.8 + 32',
+        PrintConv => 'sprintf("%.1f C",$val)',
+        PrintConvInv => '$val=~ s/\s*C//; $val',
+        # (may be invalid for non-OEM batteries)
+    },
+    0x0002 => {
+        Name => 'BatteryUnknown',
+        # appears to be an int16u value together with 0x0005 (values similar to ExtraInfo3 0x0000)
+        # seen values of appr. 800 at 23 deg C to 630 at 40 deg C for A850 with NP-FM500H battery (7.2 V nominal)
+        # i.e. inversely proportional to BatteryTemperature: can not be BatteryVoltage, must be something else ?
+        Unknown => 1,
+        Format => 'undef[4]',
+        ValueConv => sub {
+            my $val = shift;;
+            my @a = unpack("CvC",pack('v*', unpack('n*', $val)));
+            return $a[1];
+        },
+    },
+    # 0x0003: seen 0 or 16
+    # 0x0004: always 255
+    # 0x0006: int16u value together with 0x0009: same behaviour and almost same values as 0x0002
+    # 0x0007: always 3
+    0x0008 => {
+        Name => 'BatteryVoltage',
+        # 0x0008: int16u value together with 0x000b:
+        # values follow BatteryLevel: from appr.900 when battery full, to appr. 775 when empty.
+        # with factor 118 they range from appr. 7.6 to 6.6 - looks like battery voltage (nominal 7.2 V)
+        Unknown => 1,
+        Format => 'undef[4]',
+        ValueConv => sub {
+            my $val = shift;;
+            my @a = unpack("CvC",pack('v*', unpack('n*', $val)));
+            return $a[1]/118;
+        },
+        PrintConv => 'sprintf("%.2f V",$val)',
+    },
+    0x000a => {
+        # seen mostly 213 and 246, corresponding with other ImageStabilization On/Off tags.
+        Name => 'ImageStabilization2',
+        Unknown => 1, # (because the decoding is funny and possibly incomplete - PH)
+        PrintConv => {
+            191 => 'On (191)', # seen a few times with moving subject, continuous drive, bracketing
+            207 => 'On (207)', # seen once with RemoteCommander
+            210 => 'On (210)', # seen a few times with continuous drive
+            213 => 'On',
+            246 => 'Off',
+        },
+    },
+    # 0x000c: seen always decreasing values, from max. 107 to min. 0,
+    #   then jump back to high value: correlates with battery change/recharging
+    #   Seen once 255 immediately after inserting new battery, next frame OK at 106.
+    #   Validation: matches exactly with batterylevel display on camera (all 100+ values displayed as 100%)
+    0x000c => {
+        Name => 'BatteryLevel',
+        PrintConv => '"$val%"',
+        PrintConvInv => '$val=~s/\s*\%//; $val',
+    },
+    # 0x000d: always 2
+    # 0x000e: always 204
+    # 0x000f: always 0
+    # 0x0010-0x0019: always 204
+    0x001a => {
+        Name => 'ExtraInfoVersion',
+        Format => 'int8u[4]',
+        PrintConv => '$val=~tr/ /./; $val',
+        PrintConvInv => '$val=~tr/./ /; $val',
+        # always 0 1 0 1 for 0x0131 Software = DSLR-A850 v1.00
+        # always 0 2 0 4 for 0x0131 Software = DSLR-A850 v2.00
+        # seen   0 2 0 0 for 0x0131 Software = DSLR-A900 v1.00
+        # seen   0 4 0 0 for 0x0131 Software = DSLR-A900 v1.00
+        # seen   0 5 0 4 for 0x0131 Software = DSLR-A900 v2.00
+        # A850: correlates exactly with Firmware versions.
+        # A900: have there been different FW 1.0 versions ?
+    },
+);
+
+# extra hardware information (ref JR)
+%Image::ExifTool::Sony::ExtraInfo2 = (
+    %binaryDataAttrs,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    NOTES => 'Extra hardware information for the A230/290/330/380/390.',
+    0x0004 => {
+        Name => 'BatteryLevel',
+        PrintConv => '"$val%"',
+        PrintConvInv => '$val=~s/\s*\%//; $val',
+    },
+    0x0012 => {
+        Name => 'ImageStabilization',
+        PrintConv => {
+            0 => 'Off',
+            64 => 'On',
+        },
+    },
+);
+
+# extra hardware information (ref JR)
+%Image::ExifTool::Sony::ExtraInfo3 = (
+    %binaryDataAttrs,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    NOTES => q{
+        Extra hardware information for the A33, A35, A55, A450, A500, A550, A560,
+        A580 and NEX-3/5/C3/VG10.
+    },
+    0x0000 => {
+        Name => 'BatteryUnknown',
+        # seen values of appr. 870 at 10 deg C to 650 at 39 deg C for A580 with NP-FM500H battery (7.2 V nominal)
+        # i.e. inversely proportional to BatteryTemperature: can not be BatteryVoltage, must be something else ?
+        Unknown => 1,
+        Format => 'int16u',
+    },
+    0x0002 => {
+        Name => 'BatteryTemperature',
+        ValueConv => '($val - 32) / 1.8', # convert to Celsius
+        ValueConvInv => '$val * 1.8 + 32',
+        PrintConv => 'sprintf("%.1f C",$val)',
+        PrintConvInv => '$val=~ s/\s*C//; $val',
+    },
+    0x0004 => {
+        Name => 'BatteryLevel',
+        PrintConv => '"$val%"',
+        PrintConvInv => '$val=~s/\s*\%//; $val',
+    },
+    # 0x0005:  always 255
+    # from here on the differences between DSLR, SLT and NEX
+    # 0x0006 and 0x0008:
+    #   values follow BatteryLevel: start high (970, 940) when battery full,
+    #   and decrease with decreasing battery level to (850, 815)
+    #   with factor 128 they range from (7.6, 7.3) to (6.6, 6.4) - looks like battery voltage (nominal 7.2 V)
+    0x0006 => {
+        Name => 'BatteryVoltage1',
+        Format => 'int16u',
+        Condition => '$$self{Model} !~ /^(NEX-(3|5|5C|C3|VG10|VG10E))\b/',
+        ValueConv => '$val / 128',
+        ValueConvInv => '$val * 128',
+        PrintConv => 'sprintf("%.2f V",$val)',
+        PrintConvInv => '$val=~s/\s*V//; $val',
+    },
+    0x0008 => {
+        Name => 'BatteryVoltage2',
+        Format => 'int16u',
+        Condition => '$$self{Model} !~ /^(NEX-(3|5|5C|C3|VG10|VG10E))\b/',
+        ValueConv => '$val / 128',
+        ValueConvInv => '$val * 128',
+        PrintConv => 'sprintf("%.2f V",$val)',
+        PrintConvInv => '$val=~s/\s*V//; $val',
+    },
+    # 0x000a - 0x000f: 3 int16u values: probably some mode or status info:
+    # seen various 3-number-sequences for SLT and DSLR, but meaning unknown
+    # 0x000a => {
+    #     Name => 'ExtraInfo_000a',
+    #     Format => 'int16u[3]',
+    #     Condition => '$$self{Model} !~ /^(NEX-(3|5|5C|C3|VG10|VG10E))\b/',
+    # },
+    # 0x0010 seen:
+    #     176 for SLT
+    #     204 for NEX
+    #     240 for DSLR
+    0x0011 => {
+        Name => 'ImageStabilization',
+        Condition => '$$self{Model} !~ /^(NEX-(3|5|5C|C3|VG10|VG10E))\b/',
+        # usually matches 0xb026 ImageStabilization, except some images with SelfTimer and on tripod
+        PrintConv => {
+            0 => 'Off',
+            64 => 'On',
+        },
+    },
+    0x0014 => [
+        {
+            Name => 'BatteryState',
+            Condition => '$$self{Model} =~ /^SLT-/',
+            # possibly relates to "simple" batterylevel indication with battery-icon, but not completely sure
+            Notes => 'BatteryState for SLT models',
+            PrintConv => {
+                1 =>  'Empty',
+                2 =>  'Low',
+                3 =>  'Half full',
+                4 =>  'Almost full',
+                5 =>  'Full',
+            },
+        },{
+            Name => 'ExposureProgram',
+            Condition => '$$self{Model} =~ /^DSLR-(A450|A500|A550)\b/',
+            Notes => 'ExposureProgram for the A450, A500 and A550',
+            Priority => 0, # (some unknown values)
+            PrintConv => {
+                241 => 'Landscape',
+                243 => 'Aperture-priority AE',
+                245 => 'Portrait',
+                246 => 'Auto',
+                247 => 'Program AE',
+                249 => 'Macro',
+                252 => 'Sunset',
+                253 => 'Sports', #PH (A550)
+                255 => 'Manual',
+                # missing: Shutter speed priority AE, No Flash, Night View
+            },
+        },{
+            Name => 'ModeDialPosition',
+            Condition => '$$self{Model} =~ /^DSLR-/',
+            Notes => 'ModeDialPosition for other DSLR models',
+            # (decoded from A560/A580)
+            PrintConv => {
+                248 => 'No Flash',
+                249 => 'Aperture-priority AE',
+                250 => 'SCN', # <-- the reason we don't call it ExposureProgram for these models
+                251 => 'Shutter speed priority AE',
+                252 => 'Auto',
+                253 => 'Program AE',
+                254 => 'Panorama',
+                255 => 'Manual',
+            },
+        },
+    ],
+    # 0x0015: DSLR: appears to be a bitmask relating to "switch" positions:
+    #   bit 0 (  1) only seen OFF for A580
+    #   bit 1 (  2) ON = Flash down, OFF = Flash raised
+    #   bit 2 (  4) only seen ON for A580
+    #   bit 3 (  8) only seen ON for A580
+    #   bit 4 ( 16) ON = AF,         OFF = MF
+    #   bit 5 ( 32) ON = OVF,        OFF = LiveView
+    #   bit 6 ( 64) seen ON and OFF, meaning unknown
+    #   bit 7 (128) seen ON and OFF, meaning unknown
+    # 0x0016: DSLR: seen 244,245,252,254, decoded for A580 with 32GB SD and 16GB MS cards
+    # 0x0016: NEX:  seen 61,62,  125,126,  190: bits '64' and '128' appear to relate to CameraOrientation
+    # 0x0016: SLT:  seen 64 - 78, meaning unknown
+    0x0016 => [{
+        Name => 'MemoryCardConfiguration',
+        Condition => '$$self{Model} =~ /^DSLR-/',
+        PrintConv => {
+            244 => 'MemoryStick in use, SD card present',
+            245 => 'MemoryStick in use, SD slot empty',
+            252 => 'SD card in use, MemoryStick present',
+            254 => 'SD card in use, MemoryStick slot empty',
+        },
+    },{
+        Name => 'CameraOrientation',
+        Condition => '$$self{Model} =~ /^(NEX-(3|5|5C|C3|VG10|VG10E))\b/',
+        Mask => 0xc0, # (don't know what other bits mean)
+        PrintConv => {
+            0 =>  'Horizontal (normal)',
+            1 =>  'Rotate 90 CW',
+            2 =>  'Rotate 270 CW',
+            3 =>  'Rotate 180', #(NC)
+        },
+
+    }],
+    # 0x0017: seen 0 for SLT, 255 for DSLR, variable for NEX
+    0x0018 => {
+        Name => 'CameraOrientation',
+        Condition => '$$self{Model} !~ /^(NEX-(3|5|5C|C3|VG10|VG10E))\b/',
+        Mask => 0x30, # (don't know what other bits mean)
+        PrintConv => {
+            0 =>  'Horizontal (normal)',
+            1 =>  'Rotate 90 CW',
+            2 =>  'Rotate 270 CW',
+            3 =>  'Rotate 180',
+        },
+    },
+    # 0x0019:
+    #   A450/500/550:  0 - 12 and 233 - 255
+    #   A560/580:  1 or 64, seen a few 0 and 8
+    #   A33/35/55: seen 0, 1, 64
+    #   NEX:       204
+    # 0x001a, 0x001c appear to be 2 int16u values, meaning unknown
+);
+
 # shot information (ref PH)
 %Image::ExifTool::Sony::ShotInfo = (
     %binaryDataAttrs,
     GROUPS => { 0 => 'MakerNotes', 2 => 'Image' },
-    DATAMEMBER => [ 0x02, 0x30, 0x32 ],
+    DATAMEMBER => [ 0x02, 0x30, 0x32, 0x34 ],
     IS_SUBDIR => [ 0x48, 0x5e ],
     # 0x00 - byte order 'II'
@@ -1077,4 +5797,6 @@
         PrintConvInv => '$self->InverseDateTime($val,0)',
     },
+    0x1a => { Name => 'SonyImageHeight', Format => 'int16u' }, #JR
+    0x1c => { Name => 'SonyImageWidth',  Format => 'int16u' }, #JR
     0x30 => { #Jeffrey Friedl
         Name => 'FacesDetected',
@@ -1090,10 +5812,14 @@
         RawConv => '$$self{FaceInfoLength} = $val',
     },
-    #0x34 => {
-    #    # values: 'DC5303320222000', 'DC6303320222000' or 'DC7303320222000'
-    #    Name => 'UnknownString',
-    #    Format => 'string[16]',
-    #    Unknown => 1,
-    #},
+    0x34 => {
+        # oldest/other DSC/other        -
+        # older DSC models              "DC5303320222000" or "DC6303320222000"
+        # DSC-W650/W690/W730            "THm101000000000" or "THm211000000000"
+        # DSC-HX9V generation and newer "DC7303320222000"
+        Name => 'MetaVersion', # (tentative)
+        Format => 'string[16]',
+        DataMember => 'MetaVersion',
+        RawConv => '$$self{MetaVersion} = $val',
+    },
     0x48 => { # (most models: DC5303320222000 and DC6303320222000)
         Name => 'FaceInfo1',
